/****************************************************************************

  DEVHOOK 0.4x FEP sample

****************************************************************************/

#include "common.h"

// enable Kprintf to REMOTE UART PORT
// #define KPRINTF_115KBPS

PSP_MODULE_INFO("PSP DEVHOOK 0.4x FEP", 0, 1, 1);   
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER); 

extern int sceKernelExitDeleteThread(int id);



////////////////////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////////////////////
int main(int argc, char **argv)
{
	struct SceKernelLoadExecParam loadparam;
	int dh_bootmode;

	/* devhook uses pspsdk libc instead of newlib, so we ha have to set cwd */
	if (argc >= 1)
	{
		argv[0][strlen(argv[0])-10] = 0;
		sceIoChdir(argv[0]);
	}


#ifdef KPRINTF_115KBPS
	// debug mesage for remote controll I/F 
	pspDebugSioInit();
	pspDebugSioSetBaud(115200);
	pspDebugSioInstallKprintf();
	/* pspDebugInstallStdoutHandler(pspDebugSioPutData); */
#endif
	/* Commented for version 2.71 (we cannot use kernel exports on the user module)*/
	//Kprintf("HOOK BOOT FEP enter\n");
	//Kprintf("ARC  %d\n",argc);
#if 0
	for(i=0;i<argc;i++)
		Kprintf("ARG%d %s\n",i,argv[i]);
#endif

#if 0
	// OLD loadexec hook reboot
	if(dh_config.reboot_path[0])
	{
		Kprintf("LoadExec old hook boot '%s'\n",dh_config.reboot_path);

		// get target path
		strcpy(target_path,dh_config.reboot_path);
		// clear reboot path
		memset(dh_config.reboot_path,0,sizeof(dh_config.reboot_path));
		devhook_save_config(devhook_cfg_path);

		if( dh_load() )
		{
Kprintf("Can't setup & load devhoook\n");
printf("Can't load devhoook\n");
	    	sceKernelExitGame();
		}
		// run target program
		load_start(target_path);
		goto exit;
	}
#endif

	// PAD init
	sceCtrlSetSamplingCycle( 0 );
	sceCtrlSetSamplingMode( 0 );

	/* Commented for version 2.71 (we cannot use kernel exports on the user module)*/
	//Kprintf("pad initialized\n");

	// Screen Init
	pspDebugScreenInit();

	// load current config file
	devhook_load_config(devhook_cfg_path);

	dh_bootmode = dh_load();
	if( dh_bootmode < 0 )
	{
		// Can't load devhook
		sceKernelDelayThread(500000);
    	sceKernelExitGame();
	}

	// set default by FW1.00/1.50
	switch( sceKernelDevkitVersion())
	{
	case 0x01000300:
		boot_mode = 0;
		break;
	default: // 0x01050001
		boot_mode = 0; // default return VSH
		break;
	}

	// GUI menu
	fep_menu(dh_bootmode);

	// exit choice
	if(boot_mode < 0)
	{
		// set devhook config to escape devhook
#if 1
		dh_config.flags = DH_FLAG_KPRINT_UART;    // mark of return to normal
#else
		dh_config.flags = 0;    // mark of return to normal
#endif
		dh_config.flash[0] = 0; // mark of return to normal
		dhSetConfig(&dh_config);

		// exit to XMB
		sceKernelExitGame();
		return 0;
	}

	// Save ConfigFile for devhook.prx
	dh_config.magic = DH_MAGIC;
	devhook_save_config(devhook_cfg_path);

	// devhook setup & start devhook configration
	dhSetConfig(&dh_config);

	// target args
	loadparam.size = sizeof(loadparam);
	loadparam.args = strlen(target_path)+1;
	loadparam.argp = target_path;
	loadparam.key  = NULL;

	// choise boot mode

	/* Changes for version 2.71: all reboot to vsh */

	if (strcmp(dh_config.flash, "ms0:/dh/150") == 0)
	{
		dh_reboot_system(NULL, 1);
	}
	else
	{
		dh_reboot_system(NULL, 0);
	}
	
	/* Commented for version 2.71 (we cannot use kernel exports on the user module)*/
	//Kprintf("Done DEVHOOK FEP\n");

//exit:

#if 0
	pspDebugInstallStdoutHandler(NULL);
	pspDebugSioDisableKprintf();
#endif

	// remove from memory
	sceKernelExitDeleteThread(sceKernelGetThreadId());

  return 0;
}
