#ifndef __TEXT_H__
#define __TEXT_H__

/*
	devhook launcher text string
*/

/****************************************************************************
	position
****************************************************************************/

// naga10 japanese lib version
//#define CONSOLE_WIDTH  96
//#define CONSOLE_HEIGHT 27

#define CONSOLE_WIDTH  68
#define CONSOLE_HEIGHT 34

#define CENTER_X(S) ((CONSOLE_WIDTH-strlen(S))/2)

/****************************************************************************
	fep_gui.c
****************************************************************************/

#define STR_TITLE "PSP DEVHOOK Ver.0.4X by BOOSTER"

#define STR_TOPMENU  "TOP MENU"

#define STR_TM_START "START        "
#define STR_TM_UMDS  "UMD SELECT   "
#define STR_TM_FIRM  "FIRMWARE     "
#define STR_TM_CLK   "CPU CLOCK    "
#define STR_TM_BOOT  "BOOT SELECT  "
#define STR_TM_FLASH "FLASH ROM    "
#define STR_TM_OTHER "OTHER MENU   "
#define STR_TM_EXIT  "EXIT DEVHOOK "

#define STR_TG_XMB   "reboot XMB             "
#define STR_TG_UMD   "reboot UMD(1.50 only)  "
#define STR_TG_LOAD  "load run UMD(1.50 only)"
#define STR_TG_MPHGL "MPHGL(1.50 only)       "
#define STR_TG_RUMD  "RunUMD(1.50 only)      "

#define STR_UM_ANYUMD  "Image+ANYUMD         "
#define STR_UM_NOUMD   "Image NOUMD(1.50only)"
#define STR_UMD_DISC    "UMD Disc"

#define STR_VM_NOCHANGE "no change   "
#define STR_VM_2XX200   "2.xx to 2.00"

#define STR_CK_NORMAL "  no change   "

#define STR_BM_XMB "reboot XMB"
#define STR_BM_UMD "Reboot UMD"
#define STR_BM_MS  "Reboot MS "
#define STR_BM_RUN "Direct Run"

/*************************************
  other menu
*************************************/

#define STR_OM_UMDVER  "UMD SFO VERSION "
#define STR_OM_REMOTE  "REMOTE CTRL     "
#define STR_OM_PRELOAD "preload address "
#define STR_OM_RETURN  "RETURN to TOP   "

#define STR_RC_REMOTE "remote controller"
#define STR_RC_KPRINT "Kprintf(115Kbps) "

#define STR_F1_INST    "flash1: < ms0: install configfile"
#define STR_F1_BACKUP  "flash1: > ms0: backup  configfile"
#define STR_F1_CLEAN   "flash1: remove all devhook files "
#define STR_F0_FONT    "flash0: install font             "
#define STR_F0_KDRES   "flash0: install kd/resource      "
#define STR_F0_CLEAN   "flash0: remove all devhook files "

/*************************************
  information
*************************************/

#define STR_BAT_NOCONNECT "no-connect"
#define STR_BAT_UNKLNOWN  "unknown %08X"

#define STR_STS_TARGET  "TARGET  :%s (%s)"
#define STR_STS_UMDISO  "UMD-FILE:%s"
#define STR_STS_UMDMODE "UMD-MODE:%s,Ver.%s"
#define STR_STS_FLASH   "FW path :%s(%s)"
#define STR_STS_CLOCK   "CLOCK   :%03d/%03d"
#define STR_STS_REMOTE  "REMOTE  :%s"
#define STR_STS_PREADDR "PL-ADDR :%X"

#define STR_STS_DHVER   "DH Ver. :%X.%02X.%04X"
#define STR_STS_FWVER   "FW ver. :%X.%02X.%04X"
#define STR_STS_BATTERY "BATTERY :%s"

/*************************************
  message
*************************************/

#define STR_STS_KEYS    "CIRCLE:SELECT  TRIANGLE:CANCEL     HOME{L/R:CHANGE ISO (in XMB)"

#define STR_AUTORUN_WAIT  "auto start after %2d sec. PUSH CIRCLE to open menu"
#define STR_AUTORUN       "                AUTO START                    "

/****************************************************************************
	dh_load.c
****************************************************************************/

/****************************************************************************
	dh_inst.c
****************************************************************************/

#define STR_FLASH0_INST_MSG "'%s' is installed in flash0.\n"
#define STR_FLASH0_NONE_MSG "devhook isn't installed in flash0:\n"
#define STR_FLASH1_INST_MSG "'%s' is installed in flash1.\n"
#define STR_FLASH1_NONE_MSG "devhook isn't installed in flash1:\n"

#define STR_FLASH_DUP_WARNING "\n\
flash0: and flash1: can install an only one firmware version.\n\
If there is another version already, remove before install.\n"

#define STR_FLASH0_WARNING "\
This operation write flash0: device.\n\
flash0 isn't written in normal PSP operation.\n\
When failing in the writing to flash0:, there is danger which PSP never boot.\n\
The supported firmware is only version 1.50 without any MOD.\n\
Connect both of AC power and the battery.\n\
And Don't touch PSP absolutely until this operation finish.\n\
\n\
Press CIRCLE button and hold 5seconds to start\n\
Press other button to cancel\n"

#define STR_FLASH1_WARNING "\
This operation write flash1: device.\n\
flash1 was written in normal PSP operation.\n\
But PSP never boot when that the registry file can't initialize.\n\
Connect both of AC power and the battery.\n\
And Don't touch PSP absolutely until this operation finish.\n\
\n\
Press CIRCLE button and hold 1seconds to start\n\
Press other button to cancel\n"

#define STR_FLASH_NO_WARNING "\
This operation doesn't write to built-in FlashROM.\n\
\n\
Press CIRCLE button and hold 1second to start\n\
Press other button to cancel\n"

#define STR_FLASH1_BACKUP  "Backup config files\n'%s' to '%s'"
#define STR_FLASH1_WORK    "Install config files\n'%s' to '%s'"
#define STR_FLASH1_CLEANUP "Cleanup,remove all devhook files from\n'%s%s'"

#define STR_FLASH0_FONT    "Install font\n'%s' to %s'"
#define STR_FLASH0_KDRES   "Install kd/rsource (for Korean(949) char set)\n'%s' to '%s'"
#define STR_FLASH0_CLEANUP "Cleanup,remove all devhook files from\n'%s%s'"

#define STR_FLASH_CANCEL "canceled\n"
#define STR_FLASH_DONE "Pres any button to return\n"


#endif
